% cube.inc

% the eight vertices of the cube 
/cv [
[0 0 0]
[0 1 0]
[1 1 0]
[1 0 0]
[0 0 1]
[0 1 1]
[1 1 1]
[1 0 1]
] def

% add normal functions to the facial polygons
/cube [
% face 0: -z > 0
[
  [
    cv 0 get
    cv 1 get
    cv 2 get
    cv 3 get
  ]
  [0 0 -1 0]
]
% face 1: z - 1 > 0
[
  [
    cv 4 get
    cv 7 get
    cv 6 get
    cv 5 get
  ]
  [0 0 1 -1]
]
% face 2: -y > 0
[
  [
    cv 0 get
    cv 3 get
    cv 7 get
    cv 4 get
  ]
  [0 -1 0 0]
]
% face 3: y - 1 > 0
[
  [
    cv 1 get
    cv 5 get
    cv 6 get
    cv 2 get
  ]
  [0 1 0 -1]
]
% face 4: -x > 0
[
  [
    cv 0 get
    cv 4 get
    cv 5 get
    cv 1 get
  ]
  [-1 0 0 0]
]
% face 5: x - 1 > 0
[
  [
    cv 3 get
    cv 2 get
    cv 6 get
    cv 7 get
  ]
  [1 0 0 -1]
]

] def
